#ifndef GLOBALS_H
#define GLOBALS_H

#ifndef CONFIG_H
/* typedef for Word, in the appropriate architecture */
#include "config.h"
#endif /* CONFIG_H */

#define maxstring       80


typedef Char string[maxstring + 1]; /* Allow space for null terminator */


typedef union byte_order {
  int int_;
  struct
    {
#ifdef LITTLE_ENDIAN
      char _byte0, _byte1, _byte2, _byte3;
#else /* not LITTLE_ENDIAN */
#ifdef BIG_ENDIAN
      char _byte3, _byte2, _byte1, _byte0;
#else /* not BIG_ENDIAN */
  /* Never heard of something that's neither little- nor big-endian! */
      Configuration error.
#endif /* BIG_ENDIAN */
#endif /* LITTLE_ENDIAN */
      }_bytes;
}byte_order;

#define byte0(lvalue) ((byte_order *)(&lvalue))->_bytes._byte0
#define byte1(lvalue) ((byte_order *)(&lvalue))->_bytes._byte1
#define byte2(lvalue) ((byte_order *)(&lvalue))->_bytes._byte2
#define byte3(lvalue) ((byte_order *)(&lvalue))->_bytes._byte3

typedef struct int_or_bptr
{
  boolean b;
  union
  {
    int int_;
    int * bptr;
  } UU;
} int_or_bptr;

typedef struct int_or_mptr
{
  boolean b;
  union
  {
    int int_;
    Word * mptr;  /* bitmap */
  } UU;
} int_or_mptr;

#endif /* GLOBALS_H */

/* end globals.h */
